for i = 5 : 4 : 13
    % Load the mesh
    S = import_off_mesh(sprintf('../meshes/sphere_%02d.off', i));
    % Set the wave number
    k = 1;
    % Open log file
    fid = fopen(sprintf('../logs/oldnihu_col_%02d.log', i), 'w');
    % Assemble
    tic;
    [H, G] = bemHG(S, k , 'const');
    t_mat = toc;
    fprintf(fid, 'Assembly time = %g s\n', t_mat);
    % Solve
    tic;
    n = size(H,1);
    q = ones(n,1);
    p_sol = (H - 0.5*eye(n))\(G*q);
    t_sol = toc;
    fprintf(fid, 'Solution time = %g s\n', t_sol);
    % Calculate error
    p_an = -1/(1 + 1i*k);
    err = log10(mean(abs(p_an-p_sol)/abs(p_an)));
    fprintf(fid, 'Mean log10 error = %g\n', err);
    % Close log file
    fclose(fid);
end