%bemHG_const  Generate acoustic BEM system matrices
%   [H, G] = bemHG_const(nodes, elements, g, dist, k)
%   or
%   [H, G] = bemHG_const(nodes, elements, g, dist, k, points)
%   computes the acoustic BEM system matrices H and G for the case of
%   constant shape functions.
% Parameters:
%   nodes    : N x 2 matrix of xy coordinates of model vertices
%   elements : E x 2 matrix of element node indices
%   g        : Gaussian quadrature structure for LINE elements
%              obtained from GAUSSQUAD
%   dist     : Distance limits governing integration density parameter
%   k        : acoustic wave number
%   points   : optional, if not given, then the acoustuc surface matrices
%              are computed. If defined, then the field point matrices
%              are returned. Points is a M x 2 matrix containing the xy
%              coordinates of the field points
%
% Peter Fiala
% 2012
