%bemHG_lin  Generate acoustic BEM system matrices with Burton Miller method
%   [H, G] = bemHG_lin_bm(nodes, elements, g3, g4, dist, k, alpha)
%   Computes the acoustic BEM system matrices H and G for the case of
%   linear shape functions.
% Parameters:
%   nodes    : N x 3 matrix of xyz coordinates of model vertices
%   elements : matrix of element node indices. Each row describes one
%              element in the form [3 n1 n2 n3 0] for TRIA and
%              [4 n1 n2 n3 n4] for QUAD elements.
%   g3, g4   : Gaussian quadrature structure for TRIA and QUAD elements
%              obtained from GAUSSQUAD2
%   dist     : Distance limits governing integration density parameter
%   k        : acoustic wave number
%   alpha    : Burton-Miller coupling constant
%
