template <typename ElemType>
void integrate_for_each(void)
{
	for ... // each elem of this type
	{
		// integrating
		for (int i = 0; i < ElemType::num_nodes; ++i)
			// something
	}
}

integrate_for_each<tria_elem>();
integrate_for_each<linear_quad_elem>();
integrate_for_each<planar_quad_elem>();
integrate_for_each<general_quad_elem>();

d_int_for_each<tria_elem, tria_elem>();
d_int_for_each<tria_elem, linear_quad_elem>();
d_int_for_each<tria_elem, planar_quad_elem>();
d_int_for_each<tria_elem, general_quad_elem>();
d_int_for_each<linear_quad_elem, tria_elem>();
d_int_for_each<linear_quad_elem, linear_quad_elem>();
d_int_for_each<linear_quad_elem, planar_quad_elem>();
d_int_for_each<linear_quad_elem, general_quad_elem>();
d_int_for_each<planar_quad_elem, tria_elem>();
d_int_for_each<planar_quad_elem, linear_quad_elem>();
d_int_for_each<planar_quad_elem, planar_quad_elem>();
d_int_for_each<planar_quad_elem, general_quad_elem>();
d_int_for_each<general_quad_elem, tria_elem>();
d_int_for_each<general_quad_elem, linear_quad_elem>();
d_int_for_each<general_quad_elem, planar_quad_elem>();
d_int_for_each<general_quad_elem, general_quad_elem>();

typedef vector<
	tria_elem,
	linear_quad_elem,
	planar_quad_elem,
	general_quad_elem
	> elem_types;
	
call_each<elem_types, integrate_for_each>();
d_call_each<elem_types, elem_types, d_int_for_each>();


typedef bem<
	vector<tria_elem, quad_elem>,
	green_HG_kernel,
	galerkin,
	isoparametric
	> bem_t;
