#include <stdio.h>

typedef double (*fptr) (double, double);

typedef struct {
	fptr func;		/* function to bind */
	double value;	/* bind to this value */
} bound;

bound eval2(fptr func, double val)
{
	bound b = {func, val};
	return b;
}



double eval1(bound b, double y)
{
	return b.func(b.value, y);
}

double f2(double x, double y) { return x + y; }

int main()
{
	double g = eval1(eval2(f2, 2), 3);
	return 0;
}

/* C syntax */
double g = eval1(eval2(f2, 2), 3);
// C++ syntax (polymorphism)
double g = eval(eval(f2, 2), 3);
// C++ with operator overloading
double g = f2(2)(3);

template <class Ret, class Arg1, class Arg2>
typedef struct {
	Ret (*func) (Arg1, Arg2);
	Arg1 value;
} bound;

template <class Ret, class Arg1, class Arg2>
bound<Ret, Arg1, Arg2>
	eval(Ret (*func) (Arg1, Arg2), Arg val)
{
	bound<Ret, Arg1, Arg2> b = {func, val};
	return b;
}

