int f(int n) // compiled separately
{
	int sum = 0;
	for (int i = 0; i <= n; ++i)
		sum += i*i;
	return  sum;
}


int a = f(3); // compiled separately
int b = f(5);
...


int f3(void)
{
	int sum = 0;
	for (int i = 0; i <= 3; ++i)
		sum += i*i;
	return  sum;
}

int f3(void)
{
	return  14;
}

template <int N> // N compile time constant
int f(void)
{
	int sum = 0;
	for (int i = 0; i <= N; ++i)
		sum += i*i;
	return  sum;
}

int a = f<3>(); // generate and compile f for N=3
int b = f<5>(); // generate and compile f for N=5
...


template <int N>
struct f {
	static int const value =
		N == 0 ? 0 : N*N + f<N-1>::value;
};



int a = f<3>::value; // f<3>, f<2>, f<1> f<0>
int b = f<5>::value; // f<5>, f<4>

