Tutorials {#tutorials}
=========

\page tutorials

[TOC]

Basic usage
-----------

Three steps to build the first NiHu C++ executable

1. \subpage tut_mesh_building
2. \subpage tut_function_spaces
3. \subpage tut_integral_operators

Two complete examples using the C++ core only

1. \subpage tut_laplace_double_integral : A Galerkin-type singular integral
2. \subpage tut_laplace_single_integral : A Collocational-type singular integral

Acoustic application examples
-----------------------------

These examples build C++ executables that are called from the Matlab frontend

1. \subpage tut_rayleigh_integral : Acoustic radiation from a plane surface
2. \subpage tut_helmholtz_galerkin_bem
3. \subpage tut_helmholtz_bem_3d_fict
4. \subpage tut_helmholtz_bem_2d_cyl
5. \subpage tut_helmholtz_ibem_3d

Low level NiHu
--------------

1. \subpage tut_elements : how to work with finite elements
2. \subpage tut_quadrature : how to work with quadratures

Advanced topics
---------------

1. \subpage tut_couple_radiation

Customising your own NiHu
-------------------------

1. \subpage tut_custom_element : Introduce a new element/field type
2. \subpage tut_custom_singular_integrals : Specialise a singular integral for a constant triangle
3. \subpage tut_custom_kernel : Introduce a new family of PDE into the library

Other
-----

1. \subpage tut_guiggiani_hypersingular : Hypersingular integrals with Guiggiani's method


