#include "../src/bem/kernel.hpp"

class laplace_kernel;

template <>
struct kernel_traits<laplace_kernel>
{
	typedef double scalar_t;
	typedef Eigen::Matrix<scalar_t, 1, 3> x_t;
	typedef location<x_t> input_t;
	typedef double result_t;
	typedef gauss_family_tag quadrature_family_t;
	static bool const is_symmetric = true;
	static unsigned const singularity_order = 1;
	static unsigned const singular_quadrature_order = 7;
};

class unit_kernel : public kernel_base<unit_kernel>
{
public:
	typedef kernel_base<unit_kernel> base_t;
	using base_t::eval;

	static result_t const &eval(input_t const &x)
	{
		return m_result = 1.0 / (x - ;
	}

	static kernel_precision const &get_limit(unsigned idx)
	{
		return limits[idx];
	}

protected:
	static const kernel_precision limits[];	/**< \brief array of distance limits */
};

const unit_kernel::kernel_precision unit_kernel::limits[] = {
	{0.0, 0}
};

